#include <stdio.h>
#include <string.h>
#include <math.h>

long conv(char *num);

main(int nf, char **file)
{
	char s[20][100];
	char v[100];
	char p[100];
	int dati[10000];
	int ok = 0, m, n, tff, z;


	for (n = 0; n < 20; n++)
	{
		for (m = 0; m < 100; m++)
		{
			s[n][m] = 0;
		}
	}
	memset(v, 0, 100);
	strcpy(s[0], "010100");

	if (nf == 2)
	{
		strcpy(s[0], file[1]);
	}
	printf("Generatore di logica circuitale per sequenze di bit predefinite.\n");
	printf("\n.Viene generata la logica base da implementare su una serie\n");
	printf(".di FLIP FLOp di tipo D collegati in cascata modello contatore.\n\n\n");
	printf("         +-------------------------+                               \n");
	printf("         |                         |-----------------------------+ \n");
	printf("      +--|  Modulo logico generato |..                           | \n");
	printf("      |  |  dal programma.         |--------+                    | \n");
	printf("      |  |                         |-------+|                    | \n");
	printf("      |  |                         |------+||                    | \n");
	printf("      |  +-------------------------+      |||                    | \n");
	printf("      |           +-----------------------+||                    | \n");
	printf("      |           |            +-----------+|                    | \n");
	printf("      |  +-----+  |   +-----+  |   +-----+  |            +-----+ | \n");
	printf("Out <-+--|D  q1|--+---|D  q2|--+---|D  q3|--+-- .... ----|D  qn|-+ \n");
	printf("         |     |      |     |      |     |               |     |   \n");
	printf("         |  ~q1|-..   |  ~q2|-..   |  ~q3|-..            |  ~qn|-..\n");
	printf("         | c   |      | c   |      | c   |               | c   |   \n");
	printf("         +-----+      +-----+      +-----+               +-----+   \n");
	printf("           |            |            |                     |       \n");
	printf("Clock ->---+------------+------------+---------------------+       \n");


	printf("\n. I flip flop devono essere tutti di tipo D.\n");
	printf(". I valori q1,q2,q3...qn si riferiscono alle uscite dei FFD 1,2,3..n.\n\n");
	printf("SEQUENZA = [ .. %s .. ] \n\n", s[0]);
	tff = log(strlen(s[0])) / log(2);
	printf("\n.ANALISI logica e ottimizzazione del numero min. di FF necessari\n\n");
rifai:
	for (n = 0; n < strlen(s[0]) - 1; n++)
	{
		v[n] = s[0][n+1];
	}
	v[strlen(s[0])-1] = s[0][0];

	for (m = 1; m <= tff; m++)
	{
		for (n = m; n < strlen(s[0]); n++)
		{
			s[m][n] = s[0][n - m];
		}
		for (n = 0; n < m; n++)
		{
			s[m][n] = s[0][strlen(s[0]) - m + n];
		}

	}
	printf("-----------------------\n");
	printf("V q1 q2 ..  n. min di ff=%d\n", tff + 1);
	printf("-----------------------\n");
	for (n = 0; n < 10000; n++)
	{
		dati[n] = -1;
	}
	for (n = 0; n < strlen(s[0]); n++)
	{
		printf("%c ", v[n]);
		for (m = 0; m <= tff; m++)
		{
			printf("%c", s[m][n]);
		}
		memset(p, 0, 100);
		for (m = 0; m <= tff; m++)
		{
			p[m] = s[m][n];
		}
		z = v[n] == '0' ? 0 : 1;
		printf(" <%s> %3ld (%c)", p, conv(p), v[n]);

		if (dati[conv(p)] < 0)
		{
			dati[conv(p)] = z;
		}

		if (dati[conv(p)] >= 0)
		{
			if (dati[conv(p)] != z)
			{
				printf(" <- incertezza");
				ok = 1;
			}
		}

		printf("\n");

	}
	printf("-----------------------\n");

	if (ok == 1)
	{
		ok = 0;
		tff += 1;
		goto rifai;

	}

	printf("\n\nConfigurazione ottimale dei flip flop (0):\n");
	for (n = 0; n < strlen(s[0]); n++)
	{
		if (v[n] == '0')
		{
			memset(p, 0, 100);
			for (m = 0; m <= tff; m++)
			{
				p[m] = s[m][n];
			}
			printf("# %s #\n", p);
		}
	}

	printf("\n\nFunzione logica da ottimizzare con derive (0):\n\n");
	for (n = 0; n < strlen(s[0]); n++)
	{
		if (v[n] == '0')
		{
			printf("(");
			for (m = 0; m <= tff; m++)
			{
				if (s[m][n] == '0')
				{
					printf("not(q%d)", m + 1);
				}
				else
				{
					printf("q%d", m + 1);
				}
				if (m < tff)
				{
					printf(" and ");
				}
			}
			printf(")");
			if (n < strlen(s[0]) - 1)
			{
				printf(" or ");
			}
		}
	}


	printf("\n\nConfigurazione ottimale dei flip flop (1):\n");
	for (n = 0; n < strlen(s[0]); n++)
	{
		if (v[n] == '1')
		{
			memset(p, 0, 100);
			for (m = 0; m <= tff; m++)
			{
				p[m] = s[m][n];
			}
			printf("# %s #\n", p);
		}
	}

	printf("\n\nFunzione logica da ottimizzare con derive (1):\n\n");
	printf("[ settare input mode=word su Derive-Dos ]\n");
	printf("[ aggiungere come prima riga InputMode:=Word su Derive-Win ]\n\n");
	for (n = 0; n < strlen(s[0]); n++)
	{
		if (v[n] == '1')
		{
			printf("(");
			for (m = 0; m <= tff; m++)
			{
				if (s[m][n] == '0')
				{
					printf("not(q%d)", m + 1);
				}
				else
				{
					printf("q%d", m + 1);
				}
				if (m < tff)
				{
					printf(" and ");
				}
			}
			printf(")");
			if (n < strlen(s[0]) - 1)
			{
				printf(" or ");
			}
		}
	}

	printf("\n\nFunzione logica da ottimizzare con Mathematica (1):\n\n");
	printf("Or[");
	for (n = 0; n < strlen(s[0]); n++)
	{
		if (v[n] == '1')
		{
			printf("And[");
			for (m = 0; m <= tff; m++)
			{
				if (s[m][n] == '0')
				{
					printf("Not[q%d]", m + 1);
				}
				else
				{
					printf("q%d", m + 1);
				}
				if (m < tff)
				{
					printf(",");
				}
			}
			printf("]");
			if (n < strlen(s[0]) - 1)
			{
				printf(",");
			}
		}
	}
	printf("]");


	printf("\n\nPer eliminare lo stato iniziale di indeterminazione potrebbe\n");
	printf("essere necessario aggiungere a (1) la condizione:\n\n");

	printf(" or (");
	for (m = 0; m <= tff; m++)
	{
		printf(" not(q%d) ", m + 1);
		if (m < tff)
		{
			printf(" and ");
		}
	}
	printf(")\n\nFine.\n");



}

long conv(char *num)
{
	long s1 = 0, n1;
	for (n1 = 0; n1 < strlen(num); n1++)
	{
		s1 += pow(2, n1) * (num[n1] == '0' ? 0 : 1);
	}
	return s1;
}
